--[[
******************************************************************************
* luaEngine Lua Engine for Qt
* Copyright (C) 2018 Syping
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
******************************************************************************
--]]

local mainWindow
local mainLayout
local mainWidget
local menuBar
local menuFile
local menuHelp
local menuEntryExit
local menuEntryAbout
local appLabel1
local appLabel2

function main()
   mainWindow = createMainWindow()
   mainWidget = createCentralWidget(mainWindow)

   menuBar = createMenuBar(mainWindow)
   menuFile = createMenu("File", menuBar)
   menuEntryExit = createMenuEntry("Exit", menuFile)
   menuHelp = createMenu("Help", menuBar)
   menuEntryAbout = createMenuEntry("About LuaEngine", menuHelp)

   connect(menuEntryExit, "triggered()", "closeWindow")
   connect(menuEntryAbout, "triggered()", "showAboutBox")

   mainLayout = createLayout(VerticalLayout, mainWidget)

   appLabel1 = createLabel("LuaEngine greets!", mainWidget)
   layoutAddWidget(mainLayout, appLabel1)

   appLabel2 = createLabel("..and not only one time!", mainWidget)
   layoutAddWidget(mainLayout, appLabel2)

   showWidget(mainWindow, ShowNormal)

   return GuiExecuted
end

function closeWindow()
   closeWidget(mainWindow)
end

function showAboutBox(menuEntry)
   showMessageBox(InfoMessageBox, "You triggered the About Box!", "LuaEngine", mainWindow)
end

function testMessageBoxes()
   showMessageBox(InfoMessageBox, "LuaEngine Test")
   local returnCode = showMessageBox(QuestionMessageBox, "Do you press Yes or No?")
   if (returnCode == true) then
      showMessageBox(InfoMessageBox, "You have pressed Yes!")
   else
      showMessageBox(InfoMessageBox, "You have pressed No!")
   end
end
